/*********************************************************************

ZeroCrossing: count zero-crossings

*********************************************************************/

double * ZeroCrossing(double * samples, int nSamples, int window){

 double * crossings = (double *) malloc(sizeof(double) * nSamples);
 double * result = (double *) malloc(sizeof(double) * nSamples);
 double * buffer = (double *) malloc(sizeof(double) * window);
 double sum = 0.0;

 int i = 0, j = 0;

 if (crossings){

  for (i = 1; i < nSamples; i++)
   crossings[i] = (double) abs( sign(samples[i]) - sign(samples[i-1]) ) / 2.0;

  printf("Counting zero-crossings (%d)\n", window);

  for (i = 0; i < nSamples; i++){

   if (i < window/2) result[i] = 0.0;
   else if (i > nSamples-window/2) result[i] = 0.0;
   else {

    sum = 0;

    for (j = 0; j < window; j++) buffer[j] = crossings[i-window/2+j];
    Window(buffer,window,WINDOW_HAMMING);
    for (j = 0; j < window; j++) sum += buffer[j];
    result[i] = sum / (double) window;

   } /* if */

  } /* i */

 } else printf("ZeroCrossing: Failed memory allocation\n");

 free(buffer);
 free(crossings);

 return result;

}
